package net.moonleay.gimble.mixin;

import net.minecraft.client.MinecraftClient;
import net.moonleay.gimble.client.editor.ClientEditor;
import net.moonleay.gimble.editor.state.mode.ModeModifier;
import org.spongepowered.asm.mixin.Mixin;
import org.spongepowered.asm.mixin.Shadow;
import org.spongepowered.asm.mixin.injection.At;
import org.spongepowered.asm.mixin.injection.Inject;
import org.spongepowered.asm.mixin.injection.callback.CallbackInfo;
import org.spongepowered.asm.mixin.injection.callback.CallbackInfoReturnable;

@Mixin(MinecraftClient.class)
public abstract class BulldozerMixin {

    @Shadow protected int attackCooldown;

    @Inject(method = "doAttack", at = @At(value = "HEAD"))
    private void func(CallbackInfoReturnable<Boolean> cir) {
        if (!ClientEditor.INSTANCE.containsModifier(ModeModifier.BULLDOZER)){
            return;
        }
        this.attackCooldown = 0;
    }

    @Inject(method = "handleBlockBreaking", at = @At(value = "HEAD"))
    private void func2(boolean breaking, CallbackInfo ci) {
        if (!ClientEditor.INSTANCE.containsModifier(ModeModifier.BULLDOZER) || !breaking){
            return;
        }
        this.attackCooldown = 0;
    }


}
